
/*
 * Filename: example_testcase.c
 *
 * Purpose: This file contains a unit test case for the functions contained in the file example.c.
 * 
 */

/*
 * Includes
 */

#include "common_types.h"
#include "utassert.h"
#include "uttest.h"
#include "example.h"

/*
 * Function Definitions
 */

/* XXX_Function1_Test01 - Successful */
void XXX_Function1_Test01(void)
{
    int     X;
    int     Y;
    int     ReturnStatus;
    
    /* Setup Inputs */
    X = 1;
    Y = 2;

    /* Execute Test */
    ReturnStatus = XXX_Function1(X, Y);
    
    /* Verify Outputs */
    UtAssert_True(ReturnStatus == 3, "ReturnStatus == 3");
}

/* XXX_Function1_Test02 - Error - Invalid X = 0 */
void XXX_Function1_Test02(void)
{
    int     X;
    int     Y;
    int     ReturnStatus;
    
    /* Setup Inputs */
    X = 0;
    Y = 2;

    /* Execute Test */
    ReturnStatus = XXX_Function1(X, Y);
    
    /* Verify Outputs */
    UtAssert_True(ReturnStatus == -1, "ReturnStatus == -1");
}

void Example_Setup(void)
{
    /* initialize test environment to default state for every test */
}

void Example_TearDown(void)
{
    /* cleanup test environment */
}

void Example_AddTestCase(void)
{
    UtTest_Add(XXX_Function1_Test01, Example_Setup, Example_TearDown, "XXX_Function1_Test01 - Successful");
    UtTest_Add(XXX_Function1_Test02, Example_Setup, Example_TearDown, "XXX_Function1_Test02 - Error - Invalid X = 0");
}
